{
***********************************************************
*     createdlfgui.pas - a GUI unit for DLF archives
*     Author: Prof A Olowofoyeku (The African Chief)
*     Licence : FREEWARE
*     Last amended: 5 August 2004
**************************************************************
}

UNIT createdlfgui;

INTERFACE

USES
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms,
  QDialogs, QStdCtrls, QGrids;

TYPE
  TCreateDLFForm = CLASS ( TForm )
    GroupBox1 : TGroupBox;
    Edit1 : TEdit;
    Edit2 : TEdit;
    Label1 : TLabel;
    Label2 : TLabel;
    Button1 : TButton;
    Button2 : TButton;
    Button3 : TButton;
    Button4 : TButton;
    StringGrid1 : TStringGrid;
    Button5 : TButton;
    PROCEDURE Button4Click ( Sender : TObject );
    PROCEDURE Button1Click ( Sender : TObject );
    PROCEDURE Button2Click ( Sender : TObject );
    PROCEDURE FormCreate ( Sender : TObject );
    PROCEDURE FormResize ( Sender : TObject );
    PROCEDURE FormActivate ( Sender : TObject );
    PROCEDURE FormShow ( Sender : TObject );
    PROCEDURE Button3Click ( Sender : TObject );
    PROCEDURE Button5Click ( Sender : TObject );
    PROCEDURE FormClose ( Sender : TObject; VAR Action : TCloseAction );
  PRIVATE
    { Private declarations }
  PUBLIC
    { Public declarations }
    Code : Integer;
  END;

VAR
  CreateDLFForm : TCreateDLFForm;

VAR
HomeDir : String;

IMPLEMENTATION

USES dlfgui1, dlfunit;

{$R *.xfm}

FUNCTION ListFunc ( H : pDLF_Header; F : pDLF_FileRecFull )
: Integer {$ifdef Win32}STDCALL{$endif};
BEGIN
   Result := 0;
   IF Assigned ( f ) THEN
   WITH f^ DO BEGIN
    WITH CreateDLFForm.StringGrid1
    DO BEGIN
       Cells [0, FileID] := Strpas ( FName );
       Cells [1, FileID] := Strpas ( FDIR );
       Cells [2, FileID] := IntToStr ( FSize );
       Cells [3, FileID] := IntToStr ( FileID );
       Cells [4, FileID] := IntToStr ( Start );
       Cells [5, FileID] := IntToStr ( Stop );
    END;
   END;
END;

FUNCTION CreateDLFFunc ( FileName : pChar; Head : pDLF_HEADER; ID, Size, Copied : Longint )
: Integer {$ifdef Win32}STDCALL{$endif};
VAR
s, s1, s2, s3 : String;
BEGIN
   Result := 0;
   s1 := CreateDLFForm.Edit2.Text;
   s3 := ExtractFileDir ( s1 );
   WITH CreateDLFForm.StringGrid1
   DO BEGIN
     IF Copied = - 100
     THEN BEGIN
         s := Strpas ( FileName );
         s2 := ExtractFileDir ( s );
         IF s3 = s2 THEN s2 := '\';
         Delete ( s2, Pos ( s1, s2 ), Length ( s1 ) );
         Delete ( s2, Pos ( s3, s2 ), Length ( s3 ) );

         IF s2 = '' THEN s2 := '\'
           ELSE IF s2 = '\' THEN {}
             ELSE s2 := BackToFrontSlash ( s2 );

         Cells [0, ID] := ExtractFileName ( s );
         Cells [1, ID] := s2;
         Cells [2, ID] := IntToStr ( Size );
         Cells [3, ID] := IntToStr ( ID );
     END;
   END;
END;

PROCEDURE TCreateDLFForm.Button4Click ( Sender : TObject );
BEGIN
    Close;
END;

PROCEDURE TCreateDLFForm.Button1Click ( Sender : TObject );
VAR
p1 : ARRAY [0..259] OF char;
BEGIN
    IF MainForm.OpenDialog1.Execute
    THEN WITH MainForm.OpenDialog1
    DO BEGIN
        CASE Code OF
           1 :
           BEGIN
             (*
             IF FileExists ( FileName )
             THEN BEGIN
               IF MessageDlg ( 'Overwrite existing file ' + FileName + '?', mtConfirmation, mbYesNoCancel, 0 )
               = mrYes THEN {} ELSE Exit;
             END;
             *)
             Edit1.Text := FileName;
           END;

           2 :
           BEGIN
             Edit1.Text := FileName;
             Strpcopy ( p1, Edit1.Text );
             ListDLF ( p1, ListFunc );
           END;
           3 :
           BEGIN
             Edit1.Text := FileName;
           END;
        END; // CASE
    END;
END;

PROCEDURE TCreateDLFForm.Button2Click ( Sender : TObject );
VAR
s : WideString;
BEGIN
  IF NOT SelectDirectory ( 'Output directory', '.', s ) THEN Exit;
  CASE Code OF
     1 : Edit2.Text := AddSlash ( s ) + WildCard;
     2 : Edit2.Text := s;
     3 : Edit2.Text := s;
  END;
END;

PROCEDURE TCreateDLFForm.FormCreate ( Sender : TObject );
BEGIN
   Caption := DLFTitle + ' ' + DLFVersion + ' ' + DLFAuthor;
   Left := 1;
   Top := 1;
   WindowState := wsMaxiMized;
   HomeDir := ExtractFileDir ( Application.ExeName );
   Edit1.Text := AddSlash ( HomeDir ) + 'project1.dlf';
   Edit2.Text := AddSlash ( HomeDir ) + WildCard;
   {$ifdef linux}
   Width := 750;
   Height := 550;
   {$endif}
   StringGrid1.Width := Width - 20;
   WITH StringGrid1
   DO BEGIN
    Cells [0, 0] := 'File name';
    Cells [1, 0] := 'Destination';
    Cells [2, 0] := 'Size (bytes)';
    Cells [3, 0] := 'ID #';
    Cells [4, 0] := 'Start offset';
    Cells [5, 0] := 'End offset';

    ColWidths [0] := 250;
    ColWidths [1] := 200;
    ColWidths [2] := 100;
    ColWidths [3] := 80;
    ColWidths [4] := 135;
    ColWidths [5] := 135;
   END;
 END;

PROCEDURE TCreateDLFForm.FormResize ( Sender : TObject );
BEGIN
   StringGrid1.Width := Width - 20;
   StringGrid1.Height := Height - 150;
END;

PROCEDURE TCreateDLFForm.FormActivate ( Sender : TObject );
BEGIN
  {$ifndef linux}
   WindowState := wsMaxiMized;
  {$endif}
END;

PROCEDURE TCreateDLFForm.FormShow ( Sender : TObject );
BEGIN
  {$ifndef linux}
   WindowState := wsMaxiMized;
  {$endif} 
END;

PROCEDURE TCreateDLFForm.Button3Click ( Sender : TObject );
VAR
p1, p2 : ARRAY [0..259] OF char;
BEGIN
  Strpcopy ( p1, Edit1.Text );
  Strpcopy ( p2, Edit2.Text );
  CASE Code OF
     1 : begin
         IF FileExists ( Edit1.Text )
         THEN BEGIN
           IF MessageDlg ( 'Overwrite existing file ' + Edit1.Text + '?', mtConfirmation, mbYesNoCancel, 0 )
           = mrYes
              THEN DeleteFile (Edit1.Text)
                ELSE Exit;
         END;
         CreateDLF ( p1, p2, CreateDLFFunc );
     end;
     2 : ListDLF ( p1, ListFunc );
     3 : ExtractDLF ( p1, p2, CreateDLFFunc );
  END;
END;

PROCEDURE TCreateDLFForm.Button5Click ( Sender : TObject );
VAR
i : Integer;
BEGIN
   WITH StringGrid1
   DO BEGIN
     FOR i := 1 TO Pred ( RowCount ) DO Rows [i].Clear;
     FOR i := 6 TO Pred ( ColCount ) DO Cols [i].Clear;
   END;
END;

PROCEDURE TCreateDLFForm.FormClose ( Sender : TObject;
  VAR Action : TCloseAction );
BEGIN
   Button5Click ( Sender );
END;

END.
